#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include "ips.h"
#include "myfunc.h"
#include "strings.h"

static void PostProgressMessage(HWND hwndParent,UINT uMsg,UINT uNew,LPUINT lpuOld,LPTSTR lpStatus)
{
	if(!hwndParent) return;

	if(lpuOld){
		if(*lpuOld + 5 <= uNew){
			SendMessage(hwndParent,uMsg,(WPARAM)uNew,(LPARAM)lpStatus);
			*lpuOld = uNew;
		}
	}
	else
		SendMessage(hwndParent,uMsg,(WPARAM)uNew,(LPARAM)lpStatus);
}

/*****************

	IPSGW

******************/
// IPSwb_[EOF̒萔 v0.70
const BYTE g_baIPSHeader[IPS_SIZE_HEADER] = {0x50, 0x41, 0x54, 0x43, 0x48};
const BYTE g_baIPSEOF[IPS_SIZE_EOF] = {0x45, 0x4f, 0x46}; // oCgύX v0.71

// Win32̃t@Co͊֐ɒu v0.70
BOOL ips_IsIPSFile(LPCTSTR lpIPSFile)
{
	HANDLE hIPSFile = INVALID_HANDLE_VALUE;
	BYTE baHeader[IPS_SIZE_HEADER];
	DWORD n;
	BOOL blResult;

	do {

	//
	//---------------
	blResult = FALSE;
	memset(baHeader, 0, IPS_SIZE_HEADER);

	// Open ips file
	//---------------
	hIPSFile = CreateFile(lpIPSFile,
						  GENERIC_READ,
						  FILE_SHARE_READ,
						  NULL,
						  OPEN_EXISTING,
						  FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,
						  NULL);

	if (hIPSFile == INVALID_HANDLE_VALUE)
		break;

	// Check if .ips file has "PATCH" header 
	//---------------------------------------
	ReadFile(hIPSFile, baHeader, IPS_SIZE_HEADER, &n, NULL);
	if (n != IPS_SIZE_HEADER || memcmp(baHeader, g_baIPSHeader, IPS_SIZE_HEADER))
		break;

	// Specified file is IPS file
	//---------------------------
	blResult = TRUE;

	} while(0);

	// Close file
	//------------
	if (hIPSFile != INVALID_HANDLE_VALUE)
		CloseHandle(hIPSFile);

	return blResult;
}

//-------------
//@IPSpb`
//-------------

// Win32̃t@Co͊֐ɒu v0.70
// NOTE : ReadFile()lpNumberOfBytesReadp[^AWriteFile()lpNumberOfBytesWrittenp[^
//        w肵ȂƋIB
// TODO : ReadFile()̃G[`FbNsĂȂ߁A
//        EIPSt@CItZbgf[^̓rŏIĂꍇAԂG[sł
//        ES~f[^̃t@CɈ񕪏oāAG[I
//        Ȃǂ̖肪B
BOOL ips_Patch(LPCTSTR lpSrcFile, LPCTSTR lpIPSFile, LPTSTR lpLogBuf, HWND hwndParent, UINT uMsg)
{
// TODO : t@C̓ǂݍ݂Ɏsꍇւ̑Ή
#define _READ_IPS_OFFSET() ReadFile(hIPSFile, &dwOffset, IPS_SIZE_OFFSET, &n, NULL); \
						   dwOffset = IPS_READ_ARRANGE_ENDIANNESS_32(dwOffset);
	DWORD dwOffset;
	WORD wSize;
	WORD wTimes;
	BYTE bValue;
	HANDLE hIPSFile, hSrcFile; 
	BYTE baHeader[IPS_SIZE_HEADER];
	BOOL blResult;
	UINT uPercentage; // [vɕsKvɃvOXo[XVȂ悤ɂ邽߂Ɏgp
	DWORD dwSrcFileSize, dwIPSFileSize, n;
	LPVOID pBuf;

	if(!lpSrcFile || !lpIPSFile) return FALSE;

	do {

	//
	//--------------
	hIPSFile = hSrcFile = INVALID_HANDLE_VALUE;
	uPercentage = 0;
	blResult = FALSE;
	memset(baHeader, 0, IPS_SIZE_HEADER);
	pBuf = NULL;

	// TODO : ipslib.cCreateIPSFile()֐ŁAĂяoׂH
	//        (pb`t@CƂăMKoCgNX̃t@Cw肷ƃRs[ɎԂA
	//        WinIPSt[Y悤Ɍ)
	PostProgressMessage(hwndParent, uMsg, 0, NULL, STRING_IPS_RETRIEVINGFILEINFO); // "ُ̧擾..."

	// `Ñf[^̓ǂݎÃt@Cւ̏ݗp̃obt@`Nf[^
	// őTCY0xFFFFoCgmۂB
	// ֐̍ŏɍőTCYxm v0.71
	// NOTE : xőTCYmۂ邱ƂŁAAM`ÑmہEɂ鏈Ԃ
	//        ȂƂł
	// NOTE : v0.70ŁAIȃmۊ֐C֐malloc()free()Win32֐
	//        HeapAlloc()HeapFree()ɕύXB
	if (!(pBuf = MemAlloc(IPS_MAX_LENGTH))) {
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_FAILEDTOALLOCMEM); //"ذ̊mۂɎs܂B"
		break;
	}

	// Open ips file
	//---------------
	hIPSFile = CreateFile(lpIPSFile,
						  GENERIC_READ,
						  FILE_SHARE_READ,
						  NULL,
						  OPEN_EXISTING,
						  FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,
						  NULL);

	if (hIPSFile == INVALID_HANDLE_VALUE) {
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_CANTOPENFILE, lpIPSFile); // "%sJ܂B"
		break;
	}

	// Get ips file size
	//----------------------
	// NOTE : nɂ͏32rbgԂ
	dwIPSFileSize = GetFileSize(hIPSFile, &n);

	if(dwIPSFileSize == 0xFFFFFFFF && GetLastError() != NO_ERROR) { // G[
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_CANTRETRIEVEFILESIZE); // "̧ق̻ނ擾ł܂B"
		break;
	}

	// NOTE : IPSt@C0xFFFFFFFF(4G)oCg𒴂ꍇA64rbgl̉32rbg
	//        dwIPSFileSizeɕԂA֐Bnɂ͏32rbgێĂB

	if (n) { // IPSt@C̃TCY0xFFFFFFFF𒴂
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_CANTHANDLELARGEFILE); // "ނ4GB𒴂̧ق邱Ƃ͂ł܂B"
		break;
	}

	// Check if .ips file has "PATCH" header 
	//---------------------------------------
	ReadFile(hIPSFile, baHeader, IPS_SIZE_HEADER, &n, NULL);
	if (n != IPS_SIZE_HEADER
		|| memcmp(baHeader, g_baIPSHeader, IPS_SIZE_HEADER)) {
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_NOTIPSFILE, lpIPSFile);// "%śAIPŞقł͂܂B"
		break;
	}

	// Open Source file
	//------------------
	hSrcFile = CreateFile(lpSrcFile,
						  GENERIC_WRITE,
						  0,
						  NULL,
						  OPEN_EXISTING,
						  FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS,
						  NULL);

	if (hSrcFile == INVALID_HANDLE_VALUE) {
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_CANTOPENFILETOWRITE, lpSrcFile); // "%sӰނŊJ܂B"
		break;
	}

	// Get source file size
	//----------------------
	// NOTE : nɂ͏32rbgԂ
	// ̃t@C̃TCYꍇA̕ϐXV鏈ǉ v0.70
	dwSrcFileSize = GetFileSize(hSrcFile, &n);

	if (dwSrcFileSize == 0xFFFFFFFF && GetLastError() != NO_ERROR) { // G[
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_CANTRETRIEVEFILESIZE); // "̧ق̻ނ擾ł܂B"
		break;
	}

	// NOTE : ̃t@C0xFFFFFFFF(4G)oCg𒴂ꍇA64rbgl̉32rbg
	//        dwSrcFileSizeɕԂA֐B̂悤ȏꍇA32rbg̒lɉāA
	//        ItZbgsƂȂG[肵Ȃ肷B
	// NOTE : IPSt@CŌ̃t@Cɏ߂͈͂́Ãt@C̐擪(ItZbg
	//        ől0xFFFFFF + TCY̍ől0xFFFF)܂łłB

	if (n) { // ̃t@C̃TCY0xFFFFFFFF𒴂
		if (lpLogBuf)
			wsprintf(lpLogBuf, STRING_IPS_CANTHANDLELARGEFILE); // "ނ4GB𒴂̧ق邱Ƃ͂ł܂B"
		break;
	}

	// Patching
	//----------
	for(;;){
		// NOTE : C֐feof()Win32ł̎Bt@C|C^[݂̈ʒuړSetFilePointer()֐
		//        ĂяoA̖߂lt@C|C^[݂̌̈ʒu擾Bꂪt@CTCYƈv΁A
		//        t@C̏I[łB
		if (SetFilePointer(hIPSFile, 0, NULL, FILE_CURRENT) == dwIPSFileSize) {
			if (lpLogBuf)
				wsprintf(lpLogBuf, STRING_IPS_NOTFOUNDEOF); // "EOF܂B"
			break;
		}

		// 3oCg̃ItZbgf[^̓ǂݍ
		//------------------------------------
		_READ_IPS_OFFSET();

		// Update progress bar
		PostProgressMessage(hwndParent, uMsg, SetFilePointer(hIPSFile, 0, NULL, FILE_CURRENT) * 100 / dwIPSFileSize, &uPercentage, STRING_IPS_PATCHING); // "߯..."

		// Check "EOF"
		//------------
		// RST0x454f46(AsciiEOF)̂ƂAȉ̓̏ꍇEOFƂĈAȊOȂItZbgƂĈB
		// (1) 0x454f46
		//     t@CI[
		// (2) 0x454f46
		//     Truncate(3oCg)
		//     t@CI[
		// rGfBAˑ v0.71
		if (dwOffset == IPS_OFFSET_EOF) {
			// IPSt@Č݂̃ItZbg擾
			n = SetFilePointer(hIPSFile, 0, NULL, FILE_CURRENT);
			// IPSt@C̃t@C|C^[̈ʒuIPSt@CTCYƓA3AȂ킿
			// EOF(0x454f46)IPSt@CI邩Ǎ3oCg̃f[^Ă(3oCgtruncate offset
			// ܂ł)ꍇ
			if (n == dwIPSFileSize || n == dwIPSFileSize - IPS_SIZE_TRUNCATE) {
				// truncate
				// IPSt@C̃t@C|C^[̈ʒuIPSt@CTCY3AȂ킿
				// EOF(0x454f46)̌ɁA3oCgtruncateItZbg݂ꍇ
				if (n == dwIPSFileSize - IPS_SIZE_TRUNCATE) {
					// 3oCgtruncate offsetǂݍ
					_READ_IPS_OFFSET();
					// truncatẽ`FbN
					// NOTE : IPSt@Cɂ錳̃t@Cւ̑f[^̃ItZbgtruncate\
					// NOTE : ̃t@C̃TCYێĂϐdwSrcFileSizéAωꍇɍXVĂ
					if (dwOffset > dwSrcFileSize) { // truncate offset̃t@C̃TCY傫
						// G[ƂĈ
						if (lpLogBuf)
							wsprintf(lpLogBuf, STRING_IPS_INVALIDTRUNCATEINFO); // "Truncate񂪕słB"
						break;
					}
					// ̃t@Č݈ʒutruncate offsetɈړ
					SetFilePointer(hSrcFile, dwOffset, NULL, FILE_BEGIN);
					// ̃t@Ĉ̈ʒuɃt@CEOFړAtruncateB
					SetEndOfFile(hSrcFile);
					// ̃t@C̃TCYێĂϐXV v0.70
					dwSrcFileSize = dwOffset;
				}
				// ɏI
				PostProgressMessage(hwndParent, uMsg, 100, NULL, STRING_IPS_DONE); // ""
				if (lpLogBuf)
					wsprintf(lpLogBuf, STRING_IPS_PATCHEDSUCCESSFULLY, lpSrcFile); // "%s͐߯܂B"
				// 
				blResult = TRUE;
				break;
			}
		}

		// Set source file pointer
		//-------------------------
		// w肳ꂽItZbg̃t@CI[łꍇÃt@C̃t@C|C^ړ
		// IPSt@C̃ItZbgf[^̃`FbNǉ v0.70
		// NOTE : ̃t@C̏I[ɑ̃f[^𕡐̃`N(2ނ)ɕIPSt@Cl
		// NOTE : ̃t@C̃TCY
		//        @(t@C̏I[f[^2ނ̏݃[hɂ菑)
		//        @(truncateɂt@CTCY)
		//        ꍇAێĂϐdwSrcFileSizeXVĂ
		// IPSt@C̃ItZbgf[^̃`FbN폜 v0.70
		// NOTE : IPSt@ĆAK݃ItZbgɐ񂳂Ȃ΂ȂȂƂK͂ȂH
		// NOTE : 
		//                                           |<- IPSt@Cɂ鑝 ->|
		//                                           |<---- A ---->|<---- B ---->|
		//        ̃t@C |---------------------|-------------|-------------|
		//                                     t@C̏I[
		//
		//        BɃf[^ރ`N(WindowsłA̕0Ŗ߂)
		//        AɃf[^ރ`N
		//        ̏Ƀ`NۑꂽIPSt@ĆAIPSt@CłƍlׂłH
//		if (dwOffset <= dwSrcFileSize) // NOTE : t@C̏I[ւ̈ړ܂
			SetFilePointer(hSrcFile, dwOffset, NULL, FILE_BEGIN);
//		else {
			// ItZbg̎wɃG[B
//			if (lpLogBuf)
//				wsprintf(lpLogBuf, STRING_IPS_INVALIDOFFSET); // "̾ĂsłB"
//			break;
//		}

		// 2oCg̃TCYf[^̓ǂݍ
		//--------------------------------
		ReadFile(hIPSFile, &wSize, IPS_SIZE_LENGTH, &n, NULL);
		wSize = IPS_READ_ARRANGE_ENDIANNESS_16(wSize);

		if (wSize) { // AM`N
			// ֐̐擪Ŋmۂꂽ`N̍őTCỸobt@𗘗p v0.71
			// IPSt@C`Nf[^obt@ɓǂݍ
			ReadFile(hIPSFile, pBuf, wSize, &n, NULL);
			// obt@ɓǂݍ񂾃f[^̃t@Cɏ
			WriteFile(hSrcFile, pBuf, wSize, &n, NULL);
			// t@Cւ݂̏ɍsꂽ`FbN(fBXNeʕsȂ)
			if (n != (DWORD)wSize) {
				// TODO : ̃\[Xւ̊i[
				if (lpLogBuf)
					wsprintf(lpLogBuf, STRING_IPS_FAILEDTOWRITEFILE); // "̧قւ݂̏Ɏs܂B"
				break;
			}
			// ̃t@C̃TCYꍇAێĂϐXV v0.70
			// NOTE : t@C̏I[JnItZbgƂȂƂ͌Ȃ
			if (dwOffset + wSize > dwSrcFileSize)
				dwSrcFileSize = dwOffset + wSize;
		}
		else{ // EM`N
			// 2oCg̉񐔃f[^̓ǂݍ
			//------------------------------
			ReadFile(hIPSFile, &wTimes, IPS_SIZE_LENGTH, &n, NULL);
			wTimes = IPS_READ_ARRANGE_ENDIANNESS_16(wTimes);

			// 1oCg̒l̓ǂݍ
			//----------------------
			ReadFile(hIPSFile, &bValue, 1, &n, NULL);

			// Copy Data
			//-----------
			// ֐̐擪Ŋmۂꂽ`N̍őTCỸobt@𗘗p v0.71
			// NOTE : 
			//        E̊֐̌Ăяo1ōsƂŁA֐ĂяõI[o[
			//          wbh}邱Ƃł
			//        Eobt@̃oCgꂼɑ΂Ċ֐ĂяoAobt@
			//          Ŝx֐Ăяoăt@Cɏޕł
			//        Z
			//        Ememset()֐ɂ鏈KvƂȂ(̕AԂȂ)
			// NOTE : ̎̒Zɂsx̒ቺ͖ƂȂقǂł͂ȂA
			//        ȑO̎ŖƂȂsx̒ቺׂ͉łB
			memset(pBuf, bValue, wTimes);
			WriteFile(hSrcFile, pBuf, wTimes, &n, NULL);
			// ȑO̎
			// NOTE : EM`Nɂ鏑݃oCgɑIPSt@C(Ⴆ΁A
			//        ύXÕt@CoCgAύX̃t@C16MBŁAׂē
			//        oCglIPSt@C)ł́A̎łƎsxƂĂxB
//			for(i = 0;i < (DWORD)wTimes;i++)
//				WriteFile(hSrcFile, &bValue, 1, &n, NULL);

			// t@Cւ݂̏ɍsꂽ`FbN(fBXNeʕsȂ)
			if (n != (DWORD)wTimes) {
//			if (i != (DWORD)wTimes) {
				// TODO : ̃\[Xւ̊i[
				if (lpLogBuf)
					wsprintf(lpLogBuf, STRING_IPS_FAILEDTOWRITEFILE); // "̧قւ݂̏Ɏs܂B"
				break;
			}
			// ̃t@C̃TCYꍇAێĂϐXV v0.70
			// NOTE : t@C̏I[JnItZbgƂȂƂ͌Ȃ
			if (dwOffset + wTimes > dwSrcFileSize)
				dwSrcFileSize = dwOffset + wTimes;
		}
	}

	} while(0);

	// \[X
	//----------------
	if (pBuf)
		MemFree(pBuf);
	if (hIPSFile != INVALID_HANDLE_VALUE)
		CloseHandle(hIPSFile);
	if (hSrcFile != INVALID_HANDLE_VALUE)
		CloseHandle(hSrcFile);

	return blResult;
}

//-------------------
//@IPSt@C쐬
//-------------------

//
//@IPSwb_[
//
// ֐ύX v0.71
// O[oϐɕێꂽf[^gp v0.71
// TCY`萔gp v0.71
static BOOL IPSWriteHeader(HANDLE hFile)
{
	DWORD dwBytes;

	if (WriteFile(hFile, g_baIPSHeader, IPS_SIZE_HEADER, &dwBytes, NULL) 
		&& dwBytes == IPS_SIZE_HEADER)
		return TRUE;

	return FALSE;
}

//
//@Truncate
//
//  v0.71
static BOOL IPSWriteTruncate(HANDLE hFile, DWORD dwTruncateOffset)
{
	DWORD dwBytes, dwBuf;

	// NOTE : Truncate3oCgŁA0xFFFFFFőlł
	dwBuf = IPS_WRITE_ARRANGE_ENDIANNESS_32(dwTruncateOffset);
	if (dwTruncateOffset <= IPS_MAX_OFFSET // 
		&& WriteFile(hFile, &dwBuf, IPS_SIZE_OFFSET, &dwBytes, NULL) 
		&& dwBytes == IPS_SIZE_OFFSET)
		return TRUE;

	return FALSE;

}

//
//@EOF
//
// ֐ύX v0.71
// O[oϐɕێꂽf[^gp v0.71
// TCY`萔gp v0.71
static BOOL IPSWriteEOF(HANDLE hFile)
{
	DWORD dwBytes;

	if (WriteFile(hFile, g_baIPSEOF, IPS_SIZE_EOF, &dwBytes, NULL) // TCY萔pĎw v0.71
		&& dwBytes == IPS_SIZE_EOF) // ܂ꂽTCỸ`FbN v0.71
		return TRUE;

	return FALSE;
}

//
//  `No͂
//

// Absolute Mode Chunko͂
// Offset(3) | size(2) | data .. data(size)
// ꍇATRUEAt@Cւ݂̏̎s`ÑItZbgɃG[ꍇAFALSEԂB
// NOTE : TCY0xFFFF𒴂ꍇÃ`Nɕďo͂B
// TODO : ߂lƂăG[R[hԂ悤ɕύXƁAG[̎ނ[U[ɒm点邱Ƃ
//        ł悤ɂȂB
static BOOL IPSChunkWriteAbsoluteMode(DWORD dwOffset, DWORD dwSize, LPBYTE pbBuf, HANDLE hFile)
{
	DWORD dwWriteSize, dwWritten, dwBuf;
	WORD wBuf;

	while(dwSize) {

		// IPSt@ĆA0xFFFFFF(16777215)傫ȃItZbgƂłȂB
		if (dwOffset > IPS_MAX_OFFSET)
			return FALSE;

		// 񏑂o`ÑTCYvZB
		dwWriteSize = (dwSize > IPS_MAX_LENGTH) ? IPS_MAX_LENGTH : dwSize;

		// `No
		// Offset(3) | size(2) | data .. data(size)
		// ItZbg
		dwBuf = IPS_WRITE_ARRANGE_ENDIANNESS_32(dwOffset);
		if (!WriteFile(hFile, &dwBuf, IPS_SIZE_OFFSET, &dwWritten, NULL)
			|| dwWritten != IPS_SIZE_OFFSET)
			return FALSE;

		// TCY
		wBuf = (WORD)dwWriteSize;
		wBuf = IPS_WRITE_ARRANGE_ENDIANNESS_16(wBuf);
		if (!WriteFile(hFile, &wBuf, IPS_SIZE_LENGTH, &dwWritten, NULL)
			|| dwWritten != IPS_SIZE_LENGTH)
			return FALSE;

		// f[^
		if (!WriteFile(hFile, pbBuf, dwWriteSize, &dwWritten, NULL)
			|| dwWritten != dwWriteSize)
			return FALSE;

		// ItZbgƃf[^ւ̃|C^Ǝc̃TCYXV
		dwOffset += dwWriteSize;
		pbBuf += dwWriteSize;
		dwSize -= dwWriteSize;
	}

	return TRUE;
}

// Encoded Mode Chunko͂
// Offset(3) | 00 00 | Times(2) | data(1) [8oCg]
// ꍇATRUEAt@Cւ݂̏̎s`ÑItZbgɃG[ꍇAFALSEԂB
// NOTE : 񐔂0xFFFF𒴂ꍇÃ`Nɕďo͂B
// NOTE : dwTimes % 0xFFFF < 3𖞂TCỸobt@֐ɓnƁÃ`Nɕꂽۂ̍ŌEM`N
//        ͏璷B
// TODO : ߂lƂăG[R[hԂ悤ɕύXƁAG[̎ނ[U[ɒm点邱Ƃ
//        ł悤ɂȂB
static BOOL IPSChunkWriteEncodedMode(DWORD dwOffset, DWORD dwTimes, LPBYTE pbBuf, HANDLE hFile)
{
	DWORD dwWriteTimes, dwWritten, dwBuf;
	WORD wZero = 0, wBuf;

	while(dwTimes) {

		// IPSt@ĆA0xFFFFFF(16777215)傫ȃItZbgƂłȂB
		if (dwOffset > IPS_MAX_OFFSET)
			return FALSE;

		// 񏑂o`ÑTCYvZB
		dwWriteTimes = (dwTimes > IPS_MAX_LENGTH) ? IPS_MAX_LENGTH : dwTimes;

		// `No
		// Offset(3) | 00 00 | Times(2) | data(1)
		// ItZbg
		dwBuf = IPS_WRITE_ARRANGE_ENDIANNESS_32(dwOffset);
		if (!WriteFile(hFile, &dwBuf, IPS_SIZE_OFFSET, &dwWritten, NULL)
			|| dwWritten != IPS_SIZE_OFFSET)
			return FALSE;

		// 00 00
		if (!WriteFile(hFile, &wZero, IPS_SIZE_LENGTH, &dwWritten, NULL)
			|| dwWritten != IPS_SIZE_LENGTH)
			return FALSE;

		// 
		wBuf = (WORD)dwWriteTimes;
		wBuf = IPS_WRITE_ARRANGE_ENDIANNESS_16(wBuf);
		if (!WriteFile(hFile, &wBuf, IPS_SIZE_LENGTH, &dwWritten, NULL)
			|| dwWritten != IPS_SIZE_LENGTH)
			return FALSE;

		// l
		if (!WriteFile(hFile, pbBuf, 1, &dwWritten, NULL)
			|| dwWritten != 1)
			return FALSE;

		// ItZbgƎc̉񐔂XV
		// NOTE : f[^ւ̃|C^pbBufi߂Ă͂Ȃ
		dwOffset += dwWriteTimes;
		dwTimes -= dwWriteTimes;
	}

	return TRUE;
}

// ύXӏ`NƂďo
//  ERLEɂăTCYłꍇ́AIPSChunkWriteEncodedMode()֐Ăяoă`No
//  EȊȌꍇ́AIPSChunkWriteAbsoluteMode()֐Ăяoă`No

typedef struct _tagIPSCHUNKWRITE
{
	DWORD  dwOffset; // ̃`N̊JnItZbg
	LPBYTE pbAMChunk; // AM`N̐擪|C^BEM`N݂̂̏ꍇpbEMChunkƓlƂȂB
	DWORD  cbAMChunk; // pbAMChunk猻݂̃|C^܂łAM`ÑTCYBEM`N݂̂̏ꍇ0ƂȂB
	LPBYTE pbEMChunk; // EM`N̐擪|C^BEM`N₪݂ȂꍇNULLƂȂB̎ނ̃oCgl܂܂Ă\B
	DWORD  cbEMChunk; // EM`ÑTCYBEM`N₪݂Ȃꍇ0ƂȂB
	DWORD  cbEquLen; // ݂̃|C^܂ŁAoCgl񐔁B
}IPSCHUNKWRITE, FAR *LPIPSCHUNKWRITE, *PIPSCHUNKWRITE;

// EM`Nŏo͂邱ƂɂĂ̍œK\ȘA
#define IPS_THRESHOLD_EM_EM        8  // EEM  [EM] Ƒꍇ
                                      // Eoӏ̐擪œoCglAꍇ
#define IPS_THRESHOLD_EM_ONLY      3  // oӏ̂ItZbg(擪܂)Ō܂ŘAēoCglꍇ

// EM`Nŏo͂邩ǂf邽߂̃TCYoCg̘âl
#define IPS_THRESHOLD_SUM_DEFAULT  5  // ̃f[^AM`N܂܂ꍇ


// AēoCgl̑ubN܂܂Ă\obt@𑖍A
// ꂼEM`NƂďo͂B
// ꍇATRUEAt@Cւ݂̏̎s`ÑItZbgɃG[ꍇAFALSEԂB
static BOOL SubmitEncodedModeCandidate(LPBYTE pbBuf, DWORD cbSize, DWORD dwOffset, HANDLE hFile)
{
	LPBYTE pbCur;
	// EM`NƂȂf[^w|C^ŁAAoCgl̃ubN̐擪̃f[^ւ̃|C^
	LPBYTE pbEMChunk;
	// EM`ÑTCY
	DWORD cbEMChunk;
	// EM`ÑItZbg
	DWORD dwEMChunkOffset;
	// [v
	DWORD dwTimesCompare;
	// f[^̃oCg
	DWORD cbProcessed;

	// TCY0Ȃ牽s킸ɐԂ
	// NOTE : oӏׂēoCgl3oCgȉ̏ꍇAIPSWriteChunk()֐̏IŌĂ΂
	//        SubmitChunk()֐炱̊֐pbBuf != NULLAcbSize == 0ŌĂ΂ǍAAM`N
	//        ƂĒoӏŜo͂B
	// NOTE : dwTimesCompareZo֌WA0ł͂ȂB
	if (!cbSize)
		return TRUE;

	// [v񐔂vZ
	dwTimesCompare = cbSize - 1;

	//
	cbProcessed = 0;
	pbCur = 
	pbEMChunk = pbBuf;
	cbEMChunk = 1;
	dwEMChunkOffset = dwOffset;

	for (;cbProcessed < dwTimesCompare;pbCur++, cbProcessed++) {

		if (*pbCur == *(pbCur + 1)) {
			cbEMChunk++;
		}
		else {
			// EM`No
			if (!IPSChunkWriteEncodedMode(dwEMChunkOffset, cbEMChunk, pbEMChunk, hFile))
				return FALSE;
			// EM`NƂȂf[^w|C^ŁAAoCgl̃ubN̐擪̃f[^ւ̃|C^
			pbEMChunk = pbCur + 1;
			// EM`ÑTCYZbg
			cbEMChunk = 1;
			// EM`ÑItZbgZo
			dwEMChunkOffset = dwOffset + cbProcessed + 1;
		}
	}

	// cEM`No
	if (!IPSChunkWriteEncodedMode(dwEMChunkOffset, cbEMChunk, pbEMChunk, hFile))
		return FALSE;

	return TRUE;
}

// IPSCHUNKWRITE\̂ɕێꂽ`Nf[^o͂B
// ꍇATRUEAt@Cւ݂̏̎s`ÑItZbgɃG[ꍇAFALSEԂB
// NOTE : AM`N̍XVsB
// NOTE : `ÑItZbg̍XVsB
// NOTE : EM`N₪݂ꍇAEM`NƂďo͂AEM`N
//        B
static BOOL SubmitChunk(LPIPSCHUNKWRITE pICW, HANDLE hFile)
{
	// AM`N݂΁AAM`No͂
	// NOTE : EM`ŃÅ֐EM`NƂďo͂
	// NOTE : cbAMChunko[́A[vAɐmȒlł͂Ȃ
	if (pICW->pbAMChunk != pICW->pbEMChunk) { // EM`N݂̂ł͂Ȃ
		// pbAMChunko[cbAMChunkoCgAM`NƂďo
		if (!IPSChunkWriteAbsoluteMode(pICW->dwOffset, pICW->cbAMChunk, pICW->pbAMChunk, hFile))
			return FALSE;
	}

	// pbAMChunko[XV
	// NOTE : ̃`No͂邽߂ɕKvȂ߂ɕKvȏłB
	pICW->pbAMChunk += pICW->cbAMChunk + pICW->cbEMChunk;

	// dwOffseto[XV
	pICW->dwOffset += pICW->cbAMChunk;

	// cbAMChunko[XV
	// NOTE : cbAMChunko[́AAM`N݂Ȃꍇ0łB
	// NOTE : cbAMChunko[́Å֐pbAMChunko[XV̂ɎgpB
	pICW->cbAMChunk = pICW->cbEquLen - 1;

	// EM`N₪݂΁AEM`NƂďo͂AEM`NsB
	// NOTE : [v̏I[̂̊֐̌ĂяoŁAAM`N݂̂EM`N₪݂ȂꍇB
	if (pICW->pbEMChunk) { // oׂ͂EM`N݂

		// pbEMChunko[̎wf[^cbEMChunko[̕ێTCY͈̔͂EM`N
		// Ƃďo͂B
		// NOTE : pbEMChunko[̎wf[^́A8oCg蒷oCgl̃ubN
		//        ܂܂Ă\B
		if (!SubmitEncodedModeCandidate(pICW->pbEMChunk, pICW->cbEMChunk, pICW->dwOffset, hFile))
			return FALSE;

		// dwOffseto[XV
		pICW->dwOffset += pICW->cbEMChunk;

		// EM`NNA
		pICW->pbEMChunk = NULL;
		// NOTE : ̊֐pbAMChunko[̍XVɉe^邽߁Ȁ͕K{łB
		pICW->cbEMChunk = 0;
	}

	return TRUE;
}

// oύXӏEM`N𗘗pRLEks
// ꍇATRUEAt@Cւ݂̏̎s`ÑItZbgɃG[ꍇAFALSEԂB
// TODO : ItZbgEOFƓlɂȂꍇ鏈̒ǉ
// NOTE : ICW.pbEMChunk              |         NULL          |                          != NULL                             |
//                    oӏ̐擪 |<--- ICW.cbAMChunk --->|<------------ ICW.cbEMChunk ------------>|<-- ICW.cbEquLen -->|
//                        pbBuf      |ICW.pbAMChunk          |ICW.pbEMChunk       |                    |               pbCur|
//                                 |                     |                  |                    |                  |
//                        |----------|-----------------------|--------------------|--------------------|--------------------|-----
//                                                           |<-- oCgl -->|<-- oCgl -->|<-- oCgl -->|
//                                                           |      b1oCg      |      b2oCg      |      bNoCg      |
//         bN > 8 (8AoCglAM`NAEM`N̂ǂŏo͂ĂTCYɂȂ)
// NOTE : ύX_݂̂𒊏oӏƂƂɁAEM`Nŏo͂ƃTCYœKƂȂꍇ
//        |-------------------------------------------------------------------------------------|
//        |  3oCg               | oӏׂēoCgl̏ꍇ                     |
//        |                            |--------------------------------------------------------|
//        |  AoCgl  | OEM`NŃTCYœK\Ȓoӏ̍Ō   |
//        |-------------------------------------------------------------------------------------|
//        |  8oCg               | oӏ̐擪pbCur܂AM`N݂Ȃꍇ  |
//        |                            |--------------------------------------------------------|
//        |  AoCgl  | (AM`N݂̑Ɋւ炸)oӏŁAA   |
//        |                            | oCgl̑܂͕ŏIꍇ         |
//        |-------------------------------------------------------------------------------------|
//        |  (bN - 8) < 5            | (AM`N݂̑Ɋւ炸)oӏ̔Cӂ̉ӏ       |
//        |-------------------------------------------------------------------------------------|
static BOOL IPSWriteChunk(DWORD dwOffset, DWORD dwSize, LPBYTE pbBuf, HANDLE hFile)
{
	//
	LPBYTE pbCur;
	//
	IPSCHUNKWRITE ICW;
	// IPSCHUNKWRITE\̂pbEMChunko[EM`NƂďo͂ꍇɌ邱Ƃ̂łoCg
	DWORD cbDecreased;
	// EM`N(AēoCgl8oCg蒷܂͕݂)𖳏
	// EM`NƂďo͂ĂTCYœKƂȂ邩ǂtO
	BOOL fInfiniteDecreased;
	// [v
	DWORD dwTimesCompare;
	// ꂽf[^̃TCY
	DWORD cbProcessed;

	// TCY0Ȃ牽邱ƂȂ̂ŁA֐ŕԂ
	// NOTE : dwSize0łƁAdwTimesCompareZo镔Ŗ肪
	if (!dwSize)
		return TRUE;

	dwTimesCompare = dwSize - 1;
	cbProcessed = 0;
	pbCur = ICW.pbAMChunk = pbBuf;
	ICW.cbAMChunk = 0;
	ICW.pbEMChunk = NULL;
	ICW.cbEMChunk = 0;
	ICW.cbEquLen = 1;
	ICW.dwOffset = dwOffset;
	cbDecreased = 0;
	// NOTE : oӏ̐擪猻݂̃|C^܂EM`N݂̂łꍇATCYœK\ł
	fInfiniteDecreased = TRUE;

	for(;cbProcessed < dwTimesCompare;cbProcessed++, pbCur++) {

		if (*pbCur != *(pbCur + 1)) { // ̃ItZbg̃oCglƈقȂ

			if (ICW.cbEquLen > IPS_THRESHOLD_EM_EM) { // 8
				// EM`ŇƂ
				//                                    pbCur  
				//  8oCg蒷AoCgl |
				// \\\\\\\\\\\\\\\\\\\\\\

				// cbEMChunko[XV
				ICW.cbEMChunk += ICW.cbEquLen;

				// cbDecreasedXV
				cbDecreased += ICW.cbEquLen - IPS_THRESHOLD_EM_EM; // 8
			}
			else {

				if (ICW.pbEMChunk) { // EM`Ň₪݂ꍇ

					if (cbDecreased > IPS_THRESHOLD_SUM_DEFAULT // 5 // EM`Nŏo͂邱ƂŃTCYœK\ł
						|| fInfiniteDecreased) { // EM`N₪TCYœK\łƕۏ؂Ă 
						if (!SubmitChunk(&ICW, hFile))
							return FALSE;
					}
					else { // TCYœKs\ł
						// EM`NAM`NƂ
						// NOTE : ̃ItZbg̃oCglƈقȂꍇAŌICW.cbAMChunk1Z
						//        ̂ŁA1ZĂ
						ICW.cbAMChunk += ICW.cbEMChunk + ICW.cbEquLen - 1;
					}

					// NOTE : SubmitEMChunk()֐ł̃NA͍sĂ
					ICW.pbEMChunk = NULL;
					// NOTE : SubmitEncodedModeChunk()֐pbAMChunko[̍XVɉe^邽߁A
					//        ͕̏K{łB
					ICW.cbEMChunk = 0;
					// cbDecreased
					// NOTE : cbDecreasedϐ́AOオoCgl̏ꍇpbEMChunko[̏
					//        ̂ƂɂK{ł͂ȂB
					cbDecreased = 0;
				}

				// fInfiniteDecreasedtONA
				fInfiniteDecreased = FALSE;

				// cbAMChunko[̍XV
				ICW.cbAMChunk++;

			}

			// cbEquLenZbg
			ICW.cbEquLen = 1;
		}
		else { // ̃ItZbg̃oCglƓ

			if (ICW.cbEquLen == 1 && !ICW.pbEMChunk) { // 
				// EM`N
				ICW.pbEMChunk = pbCur;
				ICW.cbEMChunk = 0;
				cbDecreased = 0;
			}

			// cbEquLenXV
			ICW.cbEquLen++;

			// (cbEquLen % 0xFFFF) < N (oӏ̏I[łƂAN = 3ŁAȊÔƂAN = 8)
			//  cbEquLen > 0xFFFF𖞂ƂAꂽŌEM`N璷̂ŁA
			// h߂ɁAoCgl0xFFFF蒷ꍇAEM`NƂďo͂
			// ܂B
			if (ICW.cbEquLen == 0x10000) {
				// NOTE : ÕoCglƂ̔rŏĂƁAŖ肪B
				// NOTE : 
				// ---------------- oCgl ---------------
				// |<------- 0x10000 ------->|
				// |<------ 0xFFFF ------>|
				//                     ||
				//                     pbCur

				// cbEMChunko[̍XV
				// NOTE : SubmitChunk()֐ŁAEM`N̏o͂ۂɕKvłB
				ICW.cbEMChunk += IPS_MAX_LENGTH;

				// NOTE : cbEquLen1ŽŁȀsȂ΂ȂȂB
				// NOTE : SubmitChunk()֐ŁAcbAMChunko[̍XVɕKvłB
				ICW.cbEquLen = 1;

				//
				// NOTE : pbEMChunko[cbEMChunko[́Å֐ŏB
				if (!SubmitChunk(&ICW, hFile))
					return FALSE;

				// cbDecreasedϐ
				// NOTE : fInfiniteDecreasedtOɂEM`NTCYœK\ł邩
				//        ǂf
				cbDecreased = 0;

				// fInfiniteDecreasedtO𗧂Ă
				// NOTE : EM`N̒OTCY0xFFFFEM`Nł邱Ƃ
				fInfiniteDecreased = TRUE;
			}
		}
	}

	// c̃f[^ׂă`NƂďo͂
	if (!ICW.pbEMChunk) { // EM`N₪݂Ȃꍇ
		// c̃f[^ׂAM`NƂďo͂ꍇATCY␳
		// NOTE : EM`N₪݂ȂAȂ킿ApbEMChunkNULL̏ꍇA[vʂ钼O
		//        (pbCurXVO)ŁAȉ̂悤ȏԂɂȂĂB
		//            |<---- N bytes ---->|
		//           pbAMChunk       bpCur|
		//            |               |
		//       -|-|-|-|-|-|-| ... |-|-|-|
		//                               oӏ̏I[
		//       cbAMChunḱAN - 1łB
		ICW.cbAMChunk++;
	}
	else { // EM`N₪݂ꍇ(ICW.pbEMChunk != NULL)
		// EM`NTCYœK\ł邩ǂfAK؂ɏ
		// NOTE : fInfiniteDecreasedTRUȄꍇAȉ̂悤ȏԂl
		//        EoӏŜoCgl
		//        Eoӏ̍ŌœoCglA̒Ooӏ̐擪EM`N
		//        EEM`N₪Aoӏ̏I[܂ŘAēoCgl̑ӏ̒O
		//          TCY0xFFFFEM`N
		//        EEM`N₪ȂAoӏ̏I[܂ŘAēoCgl̑ӏ̒O
		//          TCY0xFFFFEM`N
		// NOTE : oӏׂēoCgl̏ꍇAcbDecreasedϐK؂Ȓlł͂ȂB
		// NOTE :
		//            pbEMChunk                                                        oӏ̏I[
		//                      9oCg               9oCg                9oCg  
		//        ------|----------------------|----------------------|----------------------|
		//              |<--- oCgl --->|<--- oCgl --->|<--- oCgl --->|
		//                                                            |<----- cbEquLen ----->|
		//                             cbDecreased == 2
		//        cbEquLen > 8̏ɂATCYœK\łƔfꍇɈȏ̂悤ȏԂ
		//        l邪AAoCgl8oCg蒷̕ŏIĂ邽߁A
		//        cbDecreased > 5𖞂ȂĂTCYœK\łB
		if (fInfiniteDecreased // EM`N̓TCYœK\ł
			|| cbDecreased > IPS_THRESHOLD_SUM_DEFAULT // 5 // EM`NEM`Nŏo͂ƃTCYœK\
			|| ICW.cbEquLen > IPS_THRESHOLD_EM_EM) { // 8
			// oӏ̍ŌŘA铯oCglEM`NƂďo͂邩肷B
			// NOTE : ȉ̂ǂ炩ŁA3oCg蒷oCglAꍇATCYœK\łB
			//        (1) ׂēoCglł钊oӏ
			//        (2) Õf[^EM`NŃTCYœK\ł钊oӏ̍Ō
			// NOTE : oӏׂēoCglŁA3oCgȉłꍇAcbEMChunk0ŁASubmitChunk()
			//        ֐ł͉sꂸǍɒoӏŜAM`NƂďo͂B
			// NOTE : Ō8oCg蒷AēoCglꍇȀEM`NƂB
			if (ICW.cbEquLen > IPS_THRESHOLD_EM_ONLY) { // 3
				ICW.cbEMChunk += ICW.cbEquLen;
				// NOTE : ̏ǉ΁ASubmitChunk()֐̌ĂяocbAMChunko[̒l0
				//        XV
				// NOTE : SubmitChunk()֐̌ĂяoɁAc̃f[^AM`NƂďo͂Kv̂ꍇ
				//        cbEquLeńATCYƂĕKvƂ邪Ȁ󋵂ł͎c̃f[^݂͑ȂB
//				ICW.cbEquLen = 1;
			}
		}
		else { // EM`NTCYœKs\ł
			// EM`NAM`N
			ICW.cbAMChunk += ICW.cbEMChunk + ICW.cbEquLen;
			ICW.pbEMChunk = NULL;
			ICW.cbEMChunk = 0;

			// NOTE : ̏ǉ΁ASubmitChunk()֐̌ĂяocbAMChunko[̒l0
			//        XV
			// NOTE : SubmitChunk()֐̌ĂяoɁAc̃f[^AM`NƂďo͂Kv̂ꍇ
			//        cbEquLeńATCYƂĕKvƂ邪Ȁ󋵂ł͎c̃f[^݂͑ȂB
//			ICW.cbEquLen = 1;

		}
	}
	//
	if (!SubmitChunk(&ICW, hFile))
		return FALSE;
	// ܂Ao͂ĂȂf[^΁AAM`NƂďo͂
	// NOTE : SubmitChunk()֐ŁApbEMChunko[NULLŃNAB
	if (ICW.dwOffset < dwOffset + dwSize) {
		if (!IPSChunkWriteAbsoluteMode(ICW.dwOffset, ICW.cbEquLen, ICW.pbAMChunk,hFile))
			return FALSE;
	}

	return TRUE;
}

//
//@IPSt@C̍쐬
//
// 啝ɕύX v0.71

// NOTE : 
//
// [v̏
//
// [1] ύXOŃt@CTCYłꍇ
// pbExtract |           NULL           |          != NULL         |        NULL
//           |    *pbOrg == *pbChg      |    *pbOrg != *pbChg      | *pbOrg == *pbChg
//   Org     |--------------------------|--------------------------|------------------|
//   Chg     |--------------------------|--------------------------|------------------|
//                                      |                        |
//                                      |pbExtract(Chgobt@)  |
//                                      |<------ cbExtract ------->|
//
// [2] ύXɃt@CTCYȂꍇ
//                                                                 | IPSt@Cɏo͂邱Ƃ͂Ȃ
//   Org     |-----------------------------------------------------|------------------|
//   Chg     |-----------------------------------------------------|
//                                                                 
//                                                            Truncate Offset
//
// [3] ύXɃt@CTCY傫Ȃꍇ
//                                                                 
//   Org     |-----------------------------------------------------|
//   Chg     |-----------------------------------------------------|------------------|
//                                                                 | IPSt@Cɏo͂Kv
//
// I
//
// [A] [1][2]̏ꍇɍl関o͂ł钊oӏ݂ꍇ(t@C̏I[܂ŕύXÕoCglقȂ)
//                                               t@C̏I[
//              *pbOrg == *pbChg   | *pbOrg != *pbChg  |
//   Org     ----------------------|-------------------|
//   Chg     ----------------------|-------------------|
//                                 |                 |
//                                 |pbExtract          |
//                                 |<--- cbExtract --->|
//
// [B] [3]ōl関o͂ł钊oӏƕύX̃t@C̑o͂Kv̂ꍇ
//                                            [vł̔ȑI
//              *pbOrg == *pbChg   | *pbOrg != *pbChg  |
//   Org     ----------------------|-------------------|
//   Chg     ----------------------|-------------------|-------------------------|
//                                 |                 | IPSt@Cɏo͂Kv
//                                 |pbExtract          |
//                                 |<--- cbExtract --->|
//
// [C] [3]ōlύX̃t@C݂̑̂o͂Kv̂ꍇ
//                                            [vł̔ȑI
//   pbExtract                 NULL                    |
//                        *pbOrg == *pbChg             |
//   Org     ------------------------------------------|
//   Chg     ------------------------------------------|-------------------------|
//                                                     | IPSt@Cɏo͂Kv

BOOL ips_Create(LPCTSTR szFileOrg, LPCTSTR szFileChg, LPCTSTR szFileIPS, LPTSTR szLogBuf, HWND hwndParent, UINT uMsg)
{
	FILEMEMORYINFO sFMInfoOrg = {0}; // ύXÕt@C̃[}bvgt@Cێ\
	FILEMEMORYINFO sFMInfoChg = {0}; // ύX̃t@C̃[}bvgt@Cێ\
	LPBYTE pbOrg; // ύXÕ[}bvgt@Cւ̃|C^
	LPBYTE pbChg; // ύX̃[}bvgt@Cւ̃|C^
	DWORD dwOffset; // rĂf[^̃ItZbg
	DWORD dwTimesCompare; // [vŕύXÕt@Cr
	LPBYTE pbExtract; // oύXӏ̐擪|C^
	DWORD cbExtract; // oύXӏ̃TCY
	DWORD dwExtractOffset; // oύXӏ̃ItZbg
	DWORD dwTruncateOffset; // Truncate
	HANDLE hFileIPS;
	UINT uPercentage; // [vɕsKvɃvOXo[XVȂ悤ɂ邽߂Ɏgp
	BOOL blRet;

	do {

	// [Jϐ
	blRet = FALSE;
	hFileIPS = INVALID_HANDLE_VALUE;
	uPercentage = 0;

	// TODO : ipslib.cCreateIPSFile()֐ŁAĂяoׂH
	PostProgressMessage(hwndParent, uMsg, 0, NULL, STRING_IPS_RETRIEVINGFILEINFO); // "ُ̧擾..."

	// Open unchanged file
	//---------------------
	// NOTE : t@CTCY0̋̃t@Cw肳ƁA[Ƀ}bvꂽ
	//        t@Cւ̃|C^NULLATCY0ԂāA֐͐Bv0.71
	// NOTE : t@CTCY0xFFFFFFFF𒴂t@Cw肳ƁA֐͎sB
	// NOTE : t@CTCY0xFFFFFFFF̃t@Cw肳ƁA32rbg̃[Ԃł
	//        MapViewOfFile()֐Ŏs邽߁A[}bvgt@C쐬łA֐
	//        sB
	if (!AllocateFileMemory(szFileOrg, &sFMInfoOrg)) {
		if (szLogBuf)
			wsprintf(szLogBuf, STRING_IPS_CANTOPENFILE, szFileOrg); // "%sJ܂B"
		break;
	}

	// Open changed file
	//---------------------
	// NOTE : t@CTCY0̋̃t@Cw肳ƁA[Ƀ}bvꂽ
	//        t@Cւ̃|C^NULLATCY0ԂāA֐͐Bv0.71
	// NOTE : t@CTCY0xFFFFFFFF𒴂t@Cw肳ƁA֐͎sB
	// NOTE : t@CTCY0xFFFFFFFF̃t@Cw肳ƁA32rbg̃[Ԃł
	//        MapViewOfFile()֐Ŏs邽߁A[}bvgt@C쐬łA֐
	//        sB
	if (!AllocateFileMemory(szFileChg, &sFMInfoChg)) {
		if (szLogBuf)
			wsprintf(szLogBuf, STRING_IPS_CANTOPENFILE, szFileChg); // "%sJ܂B"
		break;
	}

//	if (sFMInfoOrg.dwFileSize > sFMInfoChg.dwFileSize) {
//		if (lpLogBuf) 
//			wsprintf(lpLogBuf, STRING_IPS_FILESIZEERROR); // "ύX̧ق̻ނAύXO̻ނIPS쐬ł܂B"
//		blRet = FALSE;
//		goto EXIT_FUNCTION;
//	}

	// IPSt@Cւ̃nh擾
	hFileIPS = CreateFile(szFileIPS,
						  GENERIC_WRITE,
						  0,
						  NULL,
						  CREATE_ALWAYS,
						  0,
						  NULL);

	if (hFileIPS == INVALID_HANDLE_VALUE) {
		if (szLogBuf)
			wsprintf(szLogBuf, STRING_IPS_CANTCREATENEWFILE, szFileIPS); // "VĶق쐬ł܂B"
		break;
	}

	// TruncatedwTimesCompareϐ̏
	// NOTE : Truncate3oCgōől0xFFFFFFłB̃`FbŃAIPSWriteTruncate()֐
	//        ɂčsB
	if (sFMInfoOrg.dwFileSize > sFMInfoChg.dwFileSize) { // ύXOŁAt@CTCYȂ
		// TruncateZbg
		dwTruncateOffset = sFMInfoChg.dwFileSize;
		// [vł̔r񐔂Zbg
		dwTimesCompare = sFMInfoChg.dwFileSize;
	}
	else { // ύXOŁAt@CTCYA傫Ȃ
		// TruncateZbg
		// NOTE : Truncate񖳂
		dwTruncateOffset = IPS_OFFSET_INVALID;
		// [vł̔r񐔂Zbg
		dwTimesCompare = sFMInfoOrg.dwFileSize;
	}

	// Xe[^Xo[XV
	// NOTE : i󋵂̍XV́AIPSt@CɃ`No͂ƂɍŝŁA`N̏o͂
	//        ȂꍇAōsĂȂƃXe[^Xo[XVȂB
	PostProgressMessage(hwndParent, uMsg, 0, NULL, STRING_IPS_CREATING); // "쐬..."

	// NOTE : t@CTCY0̋̃t@Cw肳ƁANULLɂȂB
	pbOrg = sFMInfoOrg.lpPointer;
	pbChg = sFMInfoChg.lpPointer;
	dwOffset = 0;
	
	// oӏ̏
	pbExtract = NULL;
	cbExtract = 0;
	dwExtractOffset = 0;

	// IPSt@Cwb_[
	if (!IPSWriteHeader(hFileIPS)) {
		if (szLogBuf)
			wsprintf(szLogBuf, STRING_IPS_ERROROCCUR); // "쐬ɴװ܂B"
		break;
	}

	// ύXÕt@Cr
	// NOTE : pbOrgpbChĝǂ炩NULL(TCY0)ɂȂ΁AdwTimesCompare0ƂȂÃ[v
	//        ͎sȂB
	// NOTE : dwTimesCompare0xFFFFFFFFłȂB
	// NOTE : IPSt@CɕύXӏێłőItZbg𒴂ʒuɕύXӏ݂ꍇA
	//        ̕ύXӏo͂ĂȂIPSt@C쐬ÂƂ[U[ɒm点
	//        ƂBsꍇAł́AR}hvvggp
	//        ꍇɁAIPSt@CɕύXӏێłőItZbg𒴂ʒu̕ύXӏ
	//        IPSt@Cɏo͂ĂȂƂ[U[͒m邱ƂłȂB
	for(;dwOffset < dwTimesCompare;pbOrg++, pbChg++, dwOffset++){

		if (*pbOrg != *pbChg) { // ύXOňقȂ
			if (!pbExtract) { // ̎_Œoӏ݂Ȃ
				// oJn
				// oӏ̐擪|C^Zbg
				// NOTE : ύXOŃt@CTCY傫ȂAr͈͂̏I[܂ŕύXO
				//        t@CقȂꍇlāApbOrgł͂ȂApbChgpȂ΂ȂȂB
				pbExtract = pbChg;
				// oӏ̃TCYZbg
				// NOTE : K{̏ł͂Ȃ
				cbExtract = 0;
				// oӏ̃ItZbgZbg
				dwExtractOffset = dwOffset;
			}

			// oӏ̃TCY1Z
			cbExtract++;
		}
		else { // ύXOœ
			if (pbExtract) { // ̎_Œoӏ݂
				// oӏIPSt@CɃ`Nf[^Ƃď
				if (!IPSWriteChunk(dwExtractOffset, cbExtract, pbExtract, hFileIPS))
					break;
				// oӏ
				pbExtract = NULL;
				cbExtract = 0;
				// vOXo[XV
				PostProgressMessage(hwndParent, uMsg, dwOffset * 100 / dwTimesCompare, &uPercentage, STRING_IPS_CREATING); // "쐬..."
			}
		}
	}

	// [vɁAG[
	// NOTE : t@CoG[A`NItZbg̃G[
	if (dwOffset != dwTimesCompare) {
		if (szLogBuf)
			wsprintf(szLogBuf, STRING_IPS_ERROROCCUR); // "쐬ɴװ܂B"
		break;
	}

	// o͂̒oӏƕύXOŃt@CTCY傫Ȃꍇ̑f[^IPSt@C
	// `Nf[^Ƃď
	// NOTE : pbChgNULL(ύX̃t@CTCY0)̏ꍇAȉ̏𖞂Ƃ͂ȂB
	//        Ȃł邱ƂɗӂB
	if (sFMInfoChg.dwFileSize > sFMInfoOrg.dwFileSize) { // ύXOŃt@CTCY傫Ȃꍇ
		if (!pbExtract) { // ύXO̔rIŁAoӏ݂Ȃ
						  // (ύXOŔr͈͂̏I[ł)
			// oӏ̐擪|C^Zbg
			// NOTE : pbOrgł͂ȂApbChgpȂ΂ȂȂB
			pbExtract = pbChg;
			// oӏ̃TCYZbg
			// NOTE : K{̏ł͂Ȃ
			cbExtract = 0;
			// oӏ̃ItZbgZbg
			dwExtractOffset = dwOffset;
		}
		// oӏ̃TCYɕύXOő傫Ȃt@CTCYZ
		cbExtract += sFMInfoChg.dwFileSize - sFMInfoOrg.dwFileSize;
	}
	// oׂ͂oӏ݂ꍇAIPSt@CɃ`Nf[^Ƃď
	if (pbExtract) {
		if (!IPSWriteChunk(dwExtractOffset, cbExtract, pbExtract, hFileIPS)) {
			if (szLogBuf)
				wsprintf(szLogBuf, STRING_IPS_ERROROCCUR); // "쐬ɴװ܂B"
			break;
		}
	}

	// IPSt@CEOF
	// NOTE : ł̊֐̖߂l`FbNǉ΁AfBXNeʕsɂIPSt@C̏ݎs
	//        nhłB
	if (!IPSWriteEOF(hFileIPS)) {
		if (szLogBuf)
			wsprintf(szLogBuf, STRING_IPS_ERROROCCUR); // "쐬ɴװ܂B"
		break;
	}

	// Truncate̒ǉ
	if (dwTruncateOffset != IPS_OFFSET_INVALID) { // Truncateo͂Kv
		// NOTE : dwTruncateOffset0xFFFFFF𒴂ꍇG[ԂB
		if (!IPSWriteTruncate(hFileIPS, dwTruncateOffset)) {
			if (szLogBuf)
				wsprintf(szLogBuf, STRING_IPS_ERROROCCUR); // "쐬ɴװ܂B"
			break;
		}
	}

	// Xe[^Xo[ƃvOXo[XV
	PostProgressMessage(hwndParent, uMsg, 100, NULL, STRING_IPS_DONE); // ""

	// 
	if (szLogBuf)
		wsprintf(szLogBuf, STRING_IPS_CREATEDSUCCESSFULLY, szFileIPS); // "IPŞ %s 쐬܂B"

	// ֐͐
	blRet = TRUE;

	} while(0);

	// NOTE : \̂́A錾0ŏĂB
	FreeFileMemory(&sFMInfoOrg);
	FreeFileMemory(&sFMInfoChg);
	if (hFileIPS != INVALID_HANDLE_VALUE)
		CloseHandle(hFileIPS);

	return blRet;
}
