#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <string.h>
#include "ips.h"
#include "ipslib.h"
#include "myfunc.h"
#include "strings.h"

BOOL IsIPSFile(LPCTSTR lpFilePath)
{
	return ips_IsIPSFile(lpFilePath);
}

BOOL CreateIPSFile(LPIPSLIBPARAMS lpParams)
{
	LPTSTR lpOrgPath = lpParams->szFilePath1;
	LPTSTR lpChgPath = lpParams->szFilePath2;
	HWND hwndParent = lpParams->hWnd;
	BOOL blYesNo = TRUE; // R}hCɂĂяoŁAbZ[W{bNXYES{^ɂׂTRUEŏB
//	TCHAR szLog[LOG_BUFFER_SIZE]; // KvȂ v0.69
	TCHAR cIPSBuf[MAX_PATH + 1]; // +1 : NULLI[ v0.69
	TCHAR szMsg[MAX_PATH * 3 + 127]; // +27 : v0.69

	SendMessage(hwndParent,WM_IPSLIB_BEGIN,0,0);

	if(!CheckFileExistance(lpOrgPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTEXISTFILE, lpOrgPath);//wsprintf(szMsg,"%s ́A݂܂B",lpOrgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!CheckFileExistance(lpChgPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTEXISTFILE, lpChgPath); //wsprintf(szMsg,"%s ́A݂܂B",lpChgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	// ύXÕt@CƕύX̃t@C̃tpXɂȂĂȂ̃`FbNɈړ v0.69

	// IPSt@C̃tpX쐬
	if (!ChangeFileExtension(lpChgPath, cIPSBuf, (MAX_PATH + 1) * sizeof(TCHAR), TEXT("ips"))) { // +1 : NULLI[ v0.69
		// ChangeFileExtension()֐ŝ́AVgq̒̃tpX̊gqAMAX_PATH𒴂Ă܂ꍇł
		wsprintf(szMsg, STRING_IPSLIB_ERRORTOOLONGFILEPATH, lpChgPath);
		SendMessage(hwndParent, WM_IPSLIB_FINISH, FALSE, (LPARAM)szMsg);
		return FALSE; // G[`FbN v0.69
	}

	// ύXÕt@CAύX̃t@CA쐬IPSt@C̃tpXɂȂĂȂ`FbN v0.69

	// ύXÕt@CƕύX̃t@C̃tpXr(t@CɕύXӏ͂Ȃ)
	if(!lstrcmp(lpOrgPath,lpChgPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIFYSAMEFILENAME, lpOrgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	// ύXÕt@CIPSt@C̃tpXr(ύXÕt@Ĉh~B)
	// . ύXÕt@C : (tpXX).ips, ύX̃t@C : (tpXX)
	if(!lstrcmp(lpOrgPath,cIPSBuf)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIFYSAMEFILENAME, lpOrgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	// ύX̃t@CIPSt@C̃tpXr(ύX̃t@Ĉh~B)
	// . ύX̃t@C : (tpX).ips
	if(!lstrcmp(lpChgPath,cIPSBuf)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIFYSAMEFILENAME, lpChgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	wsprintf(szMsg, STRING_IPSLIB_CONFIRMCREATING, lpOrgPath, lpChgPath,cIPSBuf); //wsprintf(szMsg,"ύXO̧\n%s\nύX̧\n%s\n߯sIPŞ\n%s\n쐬܂B\n낵ł?",lpOrgPath,lpChgPath,cIPSBuf);
	SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
	if(!blYesNo){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
		return FALSE;
	}

	if(CheckFileExistance(cIPSBuf)){
		wsprintf(szMsg, STRING_IPSLIB_CONFIRMOVERWRITING ,cIPSBuf);//wsprintf(szMsg,"%s ́Ałɑ݂Ă܂B\n㏑Ă낵łH",cIPSBuf);
		SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
		if(!blYesNo){
			SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
			return FALSE;
		}
	}

	// szLogszMsg v0.69
	if(ips_Create(lpOrgPath,lpChgPath,cIPSBuf,szMsg,hwndParent,WM_IPSLIB_PROGRESS)){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,TRUE,(LPARAM)szMsg);
	}
	else{
		DeleteFile(cIPSBuf);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		// v0.68
		return FALSE;
	}

	return TRUE;
}

// TODO : ips_Patch()֐ƃG[`FbNdɍsĂ镔ɂ
BOOL IPSPatch(LPIPSLIBPARAMS lpParams)
{
	LPTSTR lpIPSPath = lpParams->szFilePath1;
	LPTSTR lpSrcPath = lpParams->szFilePath2;
	HWND hwndParent = lpParams->hWnd;
	BOOL blYesNo = TRUE; // R}hCɂĂяoŁAbZ[W{bNXYES{^ɂׂTRUEŏB
//	TCHAR szLog[LOG_BUFFER_SIZE]; // KvȂ v0.69
	TCHAR cNewBuf[MAX_PATH + 1]; // +1 : NULLI[ v0.69
	TCHAR cSrcFileExt[MAX_PATH];
	TCHAR szMsg[MAX_PATH * 3 + 127]; // +27 : v0.69

	SendMessage(hwndParent,WM_IPSLIB_BEGIN,0,0);

	if(!CheckFileExistance(lpIPSPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTEXISTFILE, lpIPSPath); //wsprintf(szMsg,"%s ́A݂܂B",lpIPSPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!CheckFileExistance(lpSrcPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTEXISTFILE, lpSrcPath);//wsprintf(szMsg,"%s ́A݂܂B",lpSrcPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!ips_IsIPSFile(lpIPSPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIPSFILE, lpIPSPath);//wsprintf(szMsg,"%s ́AIPŞقł͂܂B",lpIPSPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	// IPSt@Cƃpb`t@C̃tpXɂȂĂȂ̃`FbNɈړ v0.69

	GetFileExtension(lpSrcPath, cSrcFileExt, MAX_PATH * sizeof(TCHAR)); // v0.69 sizeof(cSrcFileExt)  MAX_PATH * sizeof(TCHAR)ɕύX
	if (!ChangeFileExtension(lpIPSPath, cNewBuf, (MAX_PATH + 1) * sizeof(TCHAR), cSrcFileExt)) { // +1 : NULLI[ v0.69
		// ChangeFileExtension()֐ŝ́AVgq̒̃tpX̊gqAMAX_PATH𒴂Ă܂ꍇł
		wsprintf(szMsg, STRING_IPSLIB_ERRORTOOLONGFILEPATH, lpIPSPath);
		SendMessage(hwndParent, WM_IPSLIB_FINISH, FALSE, (LPARAM)szMsg);
		return FALSE; // G[`FbN v0.69
	}

	// IPSt@CApb`t@CA쐬t@C̃tpXɂȂĂȂ`FbN v0.69

	// IPSt@Cƃpb`t@C̃tpXr(IPSt@CŎg̃t@CύX邱Ƃ͂Ȃ)
	if(!lstrcmp(lpIPSPath,lpSrcPath)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIFYSAMEFILENAME, lpIPSPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	// IPSt@Cƍ쐬t@C̃tpXr(IPSt@Ĉh~)
	// . IPSt@C : (fBNgY)(t@CX).ips, pb`t@C : (fBNgZ)(t@CX).ips
	if(!lstrcmp(lpIPSPath,cNewBuf)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIFYSAMEFILENAME, lpIPSPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	// pb`t@Cƍ쐬t@C̃tpXr(pb`t@Ĉh~)
	// . IPSt@C : (tpXX).ips, pb`t@C : (tpXX).bin
	if(!lstrcmp(lpSrcPath,cNewBuf)){
		wsprintf(szMsg, STRING_IPSLIB_NOTIFYSAMEFILENAME, lpSrcPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	wsprintf(szMsg, STRING_IPSLIB_CONFIRMPATCHING,lpSrcPath, cNewBuf, lpIPSPath);//wsprintf(szMsg,"̧߯\n%s\n̺߰\n%s\n쐬A̧قIPŞ\n%s\n߯܂B\n낵ł?",lpSrcPath,cNewBuf,lpIPSPath);
	SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
	if(!blYesNo){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
		return FALSE;
	}

	// OɃ`FbNǉ̂ŕKvȂ v0.69
//	if(!_stricmp(cNewBuf,lpSrcPath)){
//		wsprintf(szMsg, STRING_IPSLIB_ERRORSAMEFILENAME);//wsprintf(szMsg,"̧߯قƂ̧̺߰قɂȂĂ܂߯s܂B");
//		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
//		return FALSE;
//	}

	if(CheckFileExistance(cNewBuf)){
		wsprintf(szMsg, STRING_IPSLIB_CONFIRMOVERWRITING, cNewBuf);//wsprintf(szMsg,"%s ́Ałɑ݂Ă܂B\n㏑Ă낵łH",cNewBuf);
		SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
		if(!blYesNo){
			SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
			return FALSE;
		}

		SetFileAttributes(cNewBuf,FILE_ATTRIBUTE_NORMAL);
	}
	
	if(!CopyFile(lpSrcPath,cNewBuf,FALSE)){
		wsprintf(szMsg, STRING_IPSLIB_CANTCOPYFILE);//wsprintf(szMsg,"̧ق߰ł܂B");
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	SetFileAttributes(cNewBuf,FILE_ATTRIBUTE_NORMAL);

	// szLogszMsg v0.69
	if(ips_Patch(cNewBuf,lpIPSPath,szMsg,hwndParent,WM_IPSLIB_PROGRESS)){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,TRUE,(LPARAM)szMsg);
	}
	else{
		DeleteFile(cNewBuf);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		// v0.68
		return FALSE;
	}

	return TRUE;
}
